#ifndef OS_2
#pragma message("This Module For OS/2")
#else

#include <stdio.h>
#include <ctype.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#define INCL_NOPM
#define INCL_DOS
#define INCL_DOSERRORS
#define INCL_DOSDEVIOCTL
#include <os2.h>
#ifndef IOCTL_ASYNC
#include "os2fubar.h"
#endif
#undef CONTROL
#include "com.h"

extern void cdecl logit (char *fmt,...);

#define SLAVE

HCOMM hcModem=0;       /* comm.dll handle */

void com_DTR_on(void)
{
    DCBINFO sDCB;
    USHORT rc;

    if(!(rc=ComGetDCB(hcModem, &sDCB))){
        sDCB.fbCtlHndShake |= MODE_DTR_CONTROL;   /* raise DTR */
        ComSetDCB(hcModem, &sDCB);
    }
    else
        logit("!SYS%04u: ComGetDCB()", rc);
}

void com_DTR_off(void)
{
    DCBINFO sDCB;
    USHORT rc;

    if(!(rc=ComGetDCB(hcModem, &sDCB))){
        sDCB.fbCtlHndShake &= ~MODE_DTR_CONTROL; /* lower DTR */
        ComSetDCB(hcModem, &sDCB);
    }
    else
        logit("!SYS%04u: ComGetDCB()", rc);
}

void com_XON_disable(void)
{
    DCBINFO sDCB;
    USHORT rc;

    if(!(rc=ComGetDCB(hcModem, &sDCB))){
        /* disable auto Xmit and recv flow control */
        sDCB.fbFlowReplace &= ~(MODE_AUTO_TRANSMIT | MODE_AUTO_RECEIVE);
        ComSetDCB(hcModem, &sDCB);
    }
    else
        logit("!SYS%04u: ComGetDCB()", rc);
}

void com_XON_enable(void)
{
    DCBINFO sDCB;
    USHORT rc;

    if(!(rc=ComGetDCB(hcModem, &sDCB))){
        /* enable auto Xmit and recv flow control */
        sDCB.fbFlowReplace |= MODE_AUTO_TRANSMIT;   /*PLF Wed  04-04-1990  02:35:41 */
        ComSetDCB(hcModem, &sDCB);
    }
    else
        logit("!SYS%04u: ComGetDCB()", rc);
}

/* com_break() : start break if on==TRUE, stop break if on==FALSE */
void com_break(int on)
{
    int cmd;
    USHORT comerr,rc ;
    HFILE hf;

    cmd = (on) ? ASYNC_SETBREAKON : ASYNC_SETBREAKOFF;
    hf = ComGetFH(hcModem);
    if(hf){
        rc = DosDevIOCtl(&comerr, 0L, cmd, IOCTL_ASYNC, hf);
        if(rc)
            logit("!SYS%04u: ASYNC_SETBREAK", rc);
    }
}

#ifdef BINKLEY
extern unsigned int baud;
extern unsigned int comm_bits;
extern unsigned int parity;
extern unsigned int stop_bits;
extern struct baud_str btypes[];

void MDM_ENABLE(int ignore)
{
    long rate;
    char _parity;
    int databits;
    int stopbits;
    extern int lock_baud;
    extern int max_baud;

    if(!hcModem)
        return;

    rate = atol(btypes[baud].str);
    if(lock_baud && rate != max_baud){
        logit("#Pretending baud is %lu (locked at %u)", rate, max_baud);
        rate = max_baud;
    }
    databits = 7 + (comm_bits == BITS_8);
    stopbits = 1 + (stop_bits == STOP_2);
    switch (parity) {
	case NO_PARITY:
	    _parity = 'N';
	    break;
	case ODD_PARITY:
	    _parity = 'O';
	    break;
	case EVEN_PARITY:
	    _parity = 'E';
	    break;
    }
    ComSetBaudRate(hcModem, rate, _parity, databits, stopbits);
    ignore;
}

void MDM_DISABLE(void)
{
    if(hcModem){
        ComClose(hcModem);
        hcModem = 0;
    }
}
#endif  /* BINKLEY */

void ShowMdmSettings(void)
{
    DCBINFO dcb;
    char *On = "On";
    char *Off = "Off";
    char *dtr;
    char *rts;
    char *buffer;
    int Rx, Tx;

    if(!ComGetDCB(hcModem, &dcb)){
        logit("#Modem: TO=%s,XON(Rx)=%s,XON(Tx)=%s",
            (dcb.fbTimeout & MODE_NO_WRITE_TIMEOUT)? On : Off,
            (dcb.fbFlowReplace & MODE_AUTO_RECEIVE)? On : Off,
            (dcb.fbFlowReplace & MODE_AUTO_TRANSMIT)? On : Off);
        logit("#Modem: IDSR=%s,ODSR=%s,OCTS=%s",
            (dcb.fbCtlHndShake & MODE_DSR_SENSITIVITY)? On : Off,
            (dcb.fbCtlHndShake & MODE_DSR_HANDSHAKE)? On : Off,
            (dcb.fbCtlHndShake & MODE_CTS_HANDSHAKE)? On : Off);
        switch(dcb.fbCtlHndShake & (MODE_DTR_CONTROL | MODE_DTR_HANDSHAKE)){
            case 0: dtr = Off; break;
            case MODE_DTR_CONTROL: dtr = On; break;
            case MODE_DTR_HANDSHAKE: dtr = "IHS"; break;     /* input handshaking */
            default:
                dtr = "??"; break;
        }
        switch(dcb.fbFlowReplace & (MODE_RTS_CONTROL | MODE_RTS_HANDSHAKE | MODE_TRANSMIT_TOGGLE)){
            case 0: rts = Off;  break;
            case MODE_RTS_CONTROL: rts = On; break;
            case MODE_RTS_HANDSHAKE: rts = "IHS"; break;
            case MODE_TRANSMIT_TOGGLE: rts = "TOG"; break;
            default:
                rts = "??"; break;
        }
        switch(dcb.fbTimeout & 0x18){
            case 0: buffer = Off; break;
            case 0x08: buffer = On; break;
            case 0x10: buffer = "Auto"; break;
            default: buffer = "??"; break;
        }
        switch(dcb.fbTimeout & 0x60){
                case 0:    Rx = 1;  break;
                case 0x20: Rx = 4;  break;
                case 0x40: Rx = 8;  break;
                case 0x60: Rx = 14; break;
        }
        Tx = (dcb.fbTimeout & 0x80)? 16 : 1;
        logit("#Modem: DTR=%s,RTS=%s,BUFFER=%s (Rx=%d, Tx=%d)",
            dtr,
            rts,
            buffer,
            Rx, Tx);
        //logit("#Modem: dcb.FbTimeout  =%04X", dcb.fbTimeout);
    }
}

int Cominit(int port)
{
    char tmp[5];
    USHORT rc;
    HFILE hf;

    if(hcModem == 0){
#ifdef SLAVE
        hf = (HFILE)port+1;  /* maximus subtracts 1 from the value on the command line. Add it back here. */
        rc = ComHRegister(hf, &hcModem, 8200, 8200);
#else
        sprintf(tmp, "com%1u", port+1);
        /* Bink/Opus/Max use 8K zmodem blocks.  Make the Rx and Tx queues at
         * least that size.  This won't affect Tx much,  but we don't want
         * Rx to ever overflow.
         */
        rc = ComOpen(tmp, &hcModem, 2100, 2100);
#endif
        if(rc){
            logit("!SYS%04u:  ComOpen(%s)", rc, tmp);
            return(0);
        }
        else
            ShowMdmSettings();
    }
    else
        ComResume(hcModem);
    return (0x1954);
}

#endif /* OS_2 */
